--[[

Active Key Filter
A plugin to automatically keep your key list clean of old or inactive keys

By [RED] Espionage

http://sercodominion.org
#RED on irc.slashnet.org

Version 0.0.1

]]

-- Plugin table

akfilter = {}

-- Settings and Config

akfilter.settings = {autogo=false}
akfilter.settingsID = 3591044632
akfilter.helptext = 

[[AkFilter Commands:
/akfilter clean - Deletes all inactive keys
/akfilter auto on - Automatically deletes inactive keys at login
/akfilter auto off - Turns off automatic key cleaning
]]

-- Save Settings

function akfilter.savesettings()
	SaveSystemNotes(spickle(akfilter.settings), akfilter.settingsID)
end

-- Load Settings

function akfilter.loadsettings()
	akfilter.settings = unspickle(LoadSystemNotes(akfilter.settingsID))
end

-- Command Handler

function akfilter.command(_,args)
	if (args) then
		if (args[1]=="clean") then
			akfilter.killinactive()
			print("Inactive keys cleared")
		elseif(args[1]=="auto") then
			if (args[2]=="on") then
				akfilter.settings.autogo = true
				print("Automatically cleaning keys from now on.")
			elseif (args[2] == "off") then
				akfilter.settings.autogo = false
				print("Automatic key cleaning off")
			elseif (args[2] == "") then
				print(akfilter.helptext)
			end
		else
			print(akfilter.helptext)
		end
	else
		print(akfilter.helptext)
	end
	akfilter.savesettings()
end

-- Main functions

function akfilter.killinactive()
	local i
	for i=1,GetNumKeysInKeychain() do
		local kid,namestring,_,_,_,_,active = GetKeyInfo(i)
		if active == false then
			Keychain.deletekey(kid,namestring)
		end
	end
end

function akfilter.onstart()
	if akfilter.settings.autogo == true then
		akfilter.killinactive()
	end
end

--Load Settings, Commands and Events

akfilter.loadsettings()

RegisterUserCommand("akfilter",akfilter.command)

RegisterEvent(akfilter.loadsettings, "PLAYER_ENTERED_GAME")
RegisterEvent(akfilter.onstart,"HUD_SHOW")